<?xml version="1.0"?>
  <database name="FUNCTION ESTAX_ACCOUNTING_TAB">
    <function name="ESTAX_ACCOUNTING_TAB" type="NULL">
      <parameter name="p_pinstance_id" type="VARCHAR" mode="in">
        <default/>
      </parameter>
      <body><![CDATA[/*************************************************************************
  * The contents of this file are subject to the Openbravo  Public  License
  * Version  1.1  (the  "License"),  being   the  Mozilla   Public  License
  * Version 1.1  with a permitted attribution clause; you may not  use this
  * file except in compliance with the License. You  may  obtain  a copy of
  * the License at http://www.openbravo.com/legal/license.html
  * Software distributed under the License  is  distributed  on  an "AS IS"
  * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
  * License for the specific  language  governing  rights  and  limitations
  * under the License.
  * The Original Code is Openbravo ERP.
  * The Initial Developer of the Original Code is Openbravo SLU
  * All portions are Copyright (C) 2009-2018 Openbravo SLU
  * All Rights Reserved.
  * Contributor(s):  ______________________________________.
  ************************************************************************/
  -- Parameter
  TYPE RECORD IS REF CURSOR;
    Cur_Parameter RECORD;
    Cur_Taxes RECORD;
    Cur_Defaults RECORD;
    v_ResultStr VARCHAR2(2000):='';
    v_Org        VARCHAR2(32);
    v_Client     VARCHAR2(32);
  BEGIN
    --  Update AD_PInstance
    DBMS_OUTPUT.PUT_LINE('Updating PInstance - Processing ' || p_PInstance_ID) ;
    v_ResultStr:='No se encuentra PInstance';
    AD_UPDATE_PINSTANCE(p_PInstance_ID, NULL, 'Y', NULL, NULL) ;
    BEGIN --BODY
      -- Get Parameters
    v_ResultStr:='Leyendo parámetros';
      FOR Cur_Parameter IN
      (SELECT i.Record_ID,
        i.AD_User_ID,
        p.ParameterName,
        p.P_String,
        p.P_Number,
        p.P_Date
      FROM AD_PINSTANCE i
      LEFT JOIN AD_PINSTANCE_PARA p
      ON i.AD_PInstance_ID   =p.AD_PInstance_ID
      WHERE i.AD_PInstance_ID=p_PInstance_ID
      ORDER BY p.SeqNo
      )
    LOOP
      IF(Cur_Parameter.ParameterName='AD_Client_ID') THEN
        v_Client                   :=Cur_Parameter.P_String;
        DBMS_OUTPUT.PUT_LINE('  AD_Client_ID=' || v_Client) ;
      ELSIF(Cur_Parameter.ParameterName='AD_Org_ID') THEN
        v_Org                         :=Cur_Parameter.P_String;
        DBMS_OUTPUT.PUT_LINE('  AD_Org_ID=' || v_Org) ;
      ELSE
        DBMS_OUTPUT.PUT_LINE('*** Unknown Parameter=' || Cur_Parameter.ParameterName) ;
      END IF;
    END LOOP; -- Get Parameter
    v_ResultStr:='Procesando los rangos de impuestos';
    FOR Cur_Taxes IN
    (SELECT * FROM C_TAX T WHERE T.AD_ORG_ID = v_Org AND T.AD_CLIENT_ID=v_Client
    )
    LOOP
      FOR Cur_Defaults IN
      (SELECT           *
      FROM C_AcctSchema_Default d
      WHERE d.Ad_Client_Id=v_Client
      AND NOT EXISTS
        (SELECT 1
        FROM C_TAX_ACCT A
        WHERE A.C_TAX_ID      = Cur_Taxes.C_TAX_ID
        AND A.AD_ORG_ID       =Cur_Taxes.AD_ORG_ID
        AND A.C_ACCTSCHEMA_ID = d.C_AcctSchema_ID
        )
      AND EXISTS
        (SELECT 1
        FROM AD_Org_AcctSchema
        WHERE AD_IsOrgIncluded(v_Org, AD_Org_ID, v_Client)<>-1
        OR AD_IsOrgIncluded(AD_Org_ID, v_Org, v_Client)   <>-1
        AND IsActive                                       = 'Y'
        AND AD_Org_AcctSchema.C_AcctSchema_ID              = d.C_AcctSchema_ID
        )
      )
      LOOP
        INSERT
        INTO C_Tax_Acct
          (
            C_Tax_Acct_ID,
            C_Tax_ID,
            C_AcctSchema_ID,
            AD_Client_ID,
            AD_Org_ID,
            IsActive,
            Created,
            CreatedBy,
            Updated,
            UpdatedBy,
            T_Due_Acct,
            T_Liability_Acct,
            T_Credit_Acct,
            T_Receivables_Acct,
            T_Expense_Acct,
            T_Due_Trans_Acct,
            T_Credit_Trans_Acct
          )
          VALUES
          (
            get_uuid(),
            Cur_Taxes.C_Tax_ID,
            Cur_Defaults.C_AcctSchema_ID,
            Cur_Taxes.AD_Client_ID,
            Cur_Taxes.AD_ORG_ID,
            'Y',
            now(),
            Cur_Taxes.CreatedBy,
            now(),
            Cur_Taxes.UpdatedBy,
            Cur_Defaults.T_Due_Acct,
            Cur_Defaults.T_Liability_Acct,
            Cur_Defaults.T_Credit_Acct,
            Cur_Defaults.T_Receivables_Acct,
            Cur_Defaults.T_Expense_Acct,
            Cur_Defaults.T_Due_Trans_Acct,
            Cur_Defaults.T_Credit_Trans_Acct
          ) ;
      END LOOP;
    END LOOP;
    --  Update AD_PInstance
    DBMS_OUTPUT.PUT_LINE('Updating PInstance - Finished') ;
    AD_UPDATE_PINSTANCE(p_PInstance_ID, NULL, 'N', 1, 'Ok') ;
    RETURN;
  END; --BODY
EXCEPTION
WHEN OTHERS THEN
  v_ResultStr:= '@ERROR=' || SQLERRM;
  DBMS_OUTPUT.PUT_LINE(v_ResultStr);
  ROLLBACK;
  AD_UPDATE_PINSTANCE(p_PInstance_ID, NULL, 'N', 0, v_ResultStr);
  RETURN;
END ESTAX_ACCOUNTING_TAB
]]></body>
    </function>
  </database>
